openapi: 3.0.0
info:
  version: SRNTEST
  title: 
  description: Stock Right Now Test
servers:
  - url: http://localhost:8999/
paths:
  /SalesOrders:
    get:
      description: ''
      operationId: 'getSalesOrders'
      parameters:
        - in: query
          name: createdon
          description: The date the item was created
          required: false
          schema:
            type: string
            format: date
        - in: query
          name: updatedon
          description: The date the item was last updated
          required: false
          schema:
            type: string
            format: date
      responses:
        200:
          description: A paged collection of items including a total count of matches
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/SalesOrdersCollection'
        403:
          description: A security issue occured, an incorrect API key is the most likely cause
        400:
          description: An incorrect query parameter or condition
    post:
      description: ''
      operationId: 'createNewSalesOrders'
      requestBody:
        description: ''
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SalesOrders_Write'
      responses:
        200:
          description: The post was successful
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/PostResponse'
        403:
          description: A security issue occured, an incorrect API key is the most likely cause
  /SalesOrders/{id}:
    get:
      description: ''
      operationId: 'getSalesOrdersById'
      parameters:
        - in: path
          name: id
          description: 'The ID of the item'
          required: true
          schema:
            type: integer
      responses:
        200:
          description: A single 
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/SalesOrders'
        403:
          description: A security issue occured, an incorrect API key is the most likely cause
        400:
          description: An incorrect query parameter or condition
  /Product:
    get:
      description: ''
      operationId: 'getProduct'
      parameters:
        - in: query
          name: createdon
          description: The date the item was created
          required: false
          schema:
            type: string
            format: date
        - in: query
          name: updatedon
          description: The date the item was last updated
          required: false
          schema:
            type: string
            format: date
      responses:
        200:
          description: A paged collection of items including a total count of matches
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/ProductCollection'
        403:
          description: A security issue occured, an incorrect API key is the most likely cause
        400:
          description: An incorrect query parameter or condition
  /Product/{id}:
    get:
      description: ''
      operationId: 'getProductById'
      parameters:
        - in: path
          name: id
          description: 'The ID of the item'
          required: true
          schema:
            type: integer
      responses:
        200:
          description: A single 
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/Product'
        403:
          description: A security issue occured, an incorrect API key is the most likely cause
        400:
          description: An incorrect query parameter or condition
components:
  securitySchemes:
    apiKey:
      type: http
      scheme: bearer
  schemas:
    PostResponse:
      type: object
      properties:
        Status:
          type: string
        Message:
          type: string
        QueueEntryId:
          type: integer
        Data:
          type: array
          items:
            type: object
            properties:
              Id:
                type: integer
              TypeName:
                type: string
              Info:
                type: string
    PutResponse:
      type: object
      properties:
        Status:
          type: string
        Message:
          type: string
        QueueEntryId:
          type: integer
        Data:
          type: array
          items:
            type: object
            properties:
              Id:
                type: integer
              TypeName:
                type: string
              Info:
                type: string
    SalesOrders:
      type: object
      properties:
        ID:
          type: integer
          format: int64
        UpdatedOn:
          type: string
          format: date
        CreatedOn:
          type: string
          format: date
        Date:
          type: string
          format: date
        DueDate:
          type: string
          format: date
        Number:
          type: string
        AlternateReference:
          type: string
        Customer:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Name:
              type: string
        DeliveryContact:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            FullName:
              type: string
        Contact:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            FullName:
              type: string
        SalesContact:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            FullName:
              type: string
        CashCustomer:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            FullName:
              type: string
        SalesRep:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Name:
              type: string
        Branch:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        DespatchBranch:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        WorkflowStatus:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        OrderType:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        Currency:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        Particulars:
          type: string
        DeliveryInstructions:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Text:
              type: string
        DeliveryAgent:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        DeliveryAgentService:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        DeliveryNetAmount:
          type: number
        DeliveryTaxRate:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        DeliveryTaxAmount:
          type: number
        DeliveryGrossAmount:
          type: number
        NetAmount:
          type: number
        TaxAmount:
          type: number
        GrossAmount:
          type: number
        SourceQuotation:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Number:
              type: string
        Items:
          type: array
          items:
            type: object
            properties:
              ID:
                type: integer
                format: int64
              UpdatedOn:
                type: string
                format: date
              CreatedOn:
                type: string
                format: date
              Product:
                type: object
                properties:
                  ID:
                    type: integer
                    format: int64
                  UpdatedOn:
                    type: string
                    format: date
                  CreatedOn:
                    type: string
                    format: date
                  Code:
                    type: string
                  Description:
                    type: string
              Description:
                type: string
              Quantity:
                type: number
              QuantitySupplied:
                type: number
              NetPrice:
                type: number
              GrossPrice:
                type: number
              NetAmount:
                type: number
              DiscountPercentage:
                type: number
              DiscountAmount:
                type: number
              TaxRate:
                type: object
                properties:
                  ID:
                    type: integer
                    format: int64
                  UpdatedOn:
                    type: string
                    format: date
                  CreatedOn:
                    type: string
                    format: date
                  Code:
                    type: string
                  Description:
                    type: string
              TaxAmount:
                type: number
              GrossAmount:
                type: number
              PricingStatus:
                type: string
              CostCentre:
                type: object
                properties:
                  ID:
                    type: integer
                    format: int64
                  UpdatedOn:
                    type: string
                    format: date
                  CreatedOn:
                    type: string
                    format: date
                  Code:
                    type: string
                  Description:
                    type: string
              StockBin:
                type: object
                properties:
                  ID:
                    type: integer
                    format: int64
                  UpdatedOn:
                    type: string
                    format: date
                  CreatedOn:
                    type: string
                    format: date
                  Code:
                    type: string
                  Description:
                    type: string
              PriceSource:
                type: string
        Receipts:
          type: array
          items:
            type: object
            properties:
              ID:
                type: integer
                format: int64
              UpdatedOn:
                type: string
                format: date
              CreatedOn:
                type: string
                format: date
              ReceiptType:
                type: object
                properties:
                  ID:
                    type: integer
                    format: int64
                  UpdatedOn:
                    type: string
                    format: date
                  CreatedOn:
                    type: string
                    format: date
                  Code:
                    type: string
                  Description:
                    type: string
              Amount:
                type: number
    SalesOrders_Write:
      type: object
      properties:
        ID:
          type: integer
          format: int64
        UpdatedOn:
          type: string
          format: date
        CreatedOn:
          type: string
          format: date
        Date:
          type: string
          format: date
        DueDate:
          type: string
          format: date
        Number:
          type: string
        AlternateReference:
          type: string
        Customer:
          type: number
        DeliveryContact:
          type: number
        Contact:
          type: number
        SalesContact:
          type: number
        CashCustomer:
          type: number
        SalesRep:
          type: number
        Branch:
          type: number
        DespatchBranch:
          type: number
        WorkflowStatus:
          type: number
        OrderType:
          type: number
        Currency:
          type: number
        Particulars:
          type: string
        DeliveryInstructions:
          type: number
        DeliveryAgent:
          type: number
        DeliveryAgentService:
          type: number
        DeliveryNetAmount:
          type: number
        DeliveryTaxRate:
          type: number
        DeliveryTaxAmount:
          type: number
        DeliveryGrossAmount:
          type: number
        NetAmount:
          type: number
        TaxAmount:
          type: number
        GrossAmount:
          type: number
        SourceQuotation:
          type: number
        Items:
          type: array
          items:
            type: object
            properties:
              ID:
                type: integer
                format: int64
              UpdatedOn:
                type: string
                format: date
              CreatedOn:
                type: string
                format: date
              Product:
                type: number
              Description:
                type: string
              Quantity:
                type: number
              QuantitySupplied:
                type: number
              NetPrice:
                type: number
              GrossPrice:
                type: number
              NetAmount:
                type: number
              DiscountPercentage:
                type: number
              DiscountAmount:
                type: number
              TaxRate:
                type: number
              TaxAmount:
                type: number
              GrossAmount:
                type: number
              PricingStatus:
                type: string
              CostCentre:
                type: number
              StockBin:
                type: number
              PriceSource:
                type: string
        Receipts:
          type: array
          items:
            type: object
            properties:
              ID:
                type: integer
                format: int64
              UpdatedOn:
                type: string
                format: date
              CreatedOn:
                type: string
                format: date
              ReceiptType:
                type: number
              Amount:
                type: number
    SalesOrdersCollection:
      type: object
      properties:
        TotalCount:
          type: integer
        Data:
          type: array
          items:
            $ref: '#/components/schemas/SalesOrders'
    Product:
      type: object
      properties:
        ID:
          type: integer
          format: int64
        UpdatedOn:
          type: string
          format: date
        CreatedOn:
          type: string
          format: date
        Code:
          type: string
        Description:
          type: string
        Category:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        WorkflowStatus:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            Code:
              type: string
            Description:
              type: string
        Type:
          type: string
        Statistics:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            StockLevel:
              type: number
            OutstandingSalesOrders:
              type: number
            OutstandingPurchaseOrders:
              type: number
            AvailableStockLevel:
              type: number
        Selling:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            SellingUnits:
              type: object
              properties:
                ID:
                  type: integer
                  format: int64
                UpdatedOn:
                  type: string
                  format: date
                CreatedOn:
                  type: string
                  format: date
                Description:
                  type: string
            DefaultTaxRate:
              type: object
              properties:
                ID:
                  type: integer
                  format: int64
                UpdatedOn:
                  type: string
                  format: date
                CreatedOn:
                  type: string
                  format: date
                Code:
                  type: string
                Description:
                  type: string
        Purchasing:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            PurchaseUnits:
              type: object
              properties:
                ID:
                  type: integer
                  format: int64
                UpdatedOn:
                  type: string
                  format: date
                CreatedOn:
                  type: string
                  format: date
                Description:
                  type: string
        SellingPrice1:
          type: number
        SellingGrossPrice1:
          type: number
        ECommerceSettings:
          type: object
          properties:
            ID:
              type: integer
              format: int64
            UpdatedOn:
              type: string
              format: date
            CreatedOn:
              type: string
              format: date
            ECommerceStatus:
              type: string
    Product_Write:
      type: object
      properties:
        ID:
          type: integer
          format: int64
        UpdatedOn:
          type: string
          format: date
        CreatedOn:
          type: string
          format: date
        Code:
          type: string
        Description:
          type: string
        Category:
          type: number
        WorkflowStatus:
          type: number
        Type:
          type: string
        Statistics:
          type: number
        Selling:
          type: number
        Purchasing:
          type: number
        SellingPrice1:
          type: number
        SellingGrossPrice1:
          type: number
        ECommerceSettings:
          type: number
    ProductCollection:
      type: object
      properties:
        TotalCount:
          type: integer
        Data:
          type: array
          items:
            $ref: '#/components/schemas/Product'
security:
  - apiKey: []
